// init
// xmodem receive utility

#include "xmodem.h"

void init(void) {

    // portd bit 2 used to start data reception 
    // Pb7, Pb6, Pb5, Pb4, Pb3, Pb2, Pb1, Pb0
    //  O    O    O    O    O    O    O    O
    //  1    1    1    1    1    1    1    1
    DDRD = 0xfb;
    PORTD = 0xff; 
                                         
    TCCR1A = 0x00; // timer/counter 1 PWM disable
    TCCR1B = 0x00; // timer/counter 1 clock disable

    TIMSK |= 0x80; // enable timer counter 1 interrupt on overflow

    UCR = 0x98; // enable receiver, transmitter, and receiver interrupt
//    UBRR = 23; // 19.2k with 7.3728Mhz crystal
//    UBRR = 11; // 38.4k with 7.3728Mhz crystal
//    UBRR = 7; // 57.6k with 7.3728Mhz crystal
    UBRR = 3; // 115.2k with 7.3728Mhz crystal
                
}
