// purge
// xmodem receive utility

#include "xmodem.h"

extern struct global
{ 
  volatile unsigned char *recv_ptr; 
  volatile unsigned char buffer_status;
  volatile unsigned char recv_error;
  volatile unsigned char t1_timed_out;
} gl;

// wait 1 second for sender to empty its transmit buffer         
void purge(void) 
{

  unsigned char flush;

    gl.t1_timed_out = false;

    // 1 second timeout
    // 7.3728MHz / 1024 = 7200 Hz
    // 7200 Hz = 138.8 us
    // 1 seconds / 138.8 us = 7200
    // 65536 - 7200 = 58336 = e3e0
    // interrupt on ffff to 0000 transition
    TCNT1H = 0xe3;  
    TCNT1L = 0xe0; // load counter
    TCCR1B = 0x05; // timer/counter 1 clock / 1024

    while (!gl.t1_timed_out) // read uart until done
    {
        flush = UDR;
    }
    TCCR1B = 0x00; // disable timer/counter 1 clock
}
