// receive
// xmodem receive utility

#include "xmodem.h"

extern struct global
{ 
  volatile unsigned char *recv_ptr; 
  volatile unsigned char buffer_status;
  volatile unsigned char recv_error;
  volatile unsigned char t1_timed_out;
} gl;

// function prototypes
unsigned char validate_packet(unsigned char *bufptr, unsigned char packet_number);
void respond(unsigned char packet);
void recv_wait(void);
void sendc(void);                    
 
void receive(volatile unsigned char *bufptr1) 
{
  unsigned char packet;                 // status flag
  unsigned char packet_number;
                     
  packet_number = 0x00;                 // xmodem packets start at 1
  gl.recv_ptr = bufptr1;                // point to recv buffer

  sendc();                              // send a 'c' until the buffer gets full
  packet = validate_packet(bufptr1,packet_number); // validate packet 1
  gl.recv_ptr = bufptr1;                // re-initialize buffer pointer before acknowledging
  respond(packet);                      // ack or nak

  while (packet != good)                // if we nak'ed above wait for packet 1 again
  {
    recv_wait();
    packet = validate_packet(bufptr1,packet_number); // validate packet 1
    gl.recv_ptr = bufptr1;          // re-initialize buffer pointer before acknowledging
    respond(packet);                // ack or nak
  }
  while (packet != end)               // get remainder of file
  {
    recv_wait();                      // wait for error or buffer full
    packet = validate_packet(bufptr1,packet_number);  // validate the packet
    gl.recv_ptr = bufptr1;            // re-initialize buffer pointer before acknowledging
    respond(packet);                  // ack or nak
  }                                   // end of file transmission
}
