// recv_wait
// xmodem receive utility

#include "xmodem.h"
  
extern struct global
{
  volatile unsigned char *recv_ptr;
  volatile unsigned char buffer_status;
  volatile unsigned char recv_error;
  volatile unsigned char t1_timed_out;
} gl;
 
//extern volatile unsigned char buffer_status;
//extern volatile unsigned char t1_timed_out;
//extern volatile unsigned char recv_error; 

void recv_wait(void) 
{
    gl.t1_timed_out = false;                    // set in timer counter 0 overflow interrupt routine

    // 1 second timeout
    // 7.3728MHz / 1024 = 7200 Hz
    // 7200 Hz = 138.8 us
    // 1 seconds / 138.8 us = 7200
    // 65536 - 7200 = 58336 = e3e0
    // interrupt on ffff to 0000 transition
    TCNT1H = 0xe3;  
    TCNT1L = 0xe0;                            // load counter
    TCCR1B = 0x05;                            // timer/counter 1 clock / 1024
 
                                            // wait for packet, error, or timeout
    while (!gl.buffer_status && !gl.t1_timed_out);
                                            // turn off timer - no more time outs needed                                                            
    TCCR1B = 0x00;                          // disable timer/counter 1 clock
 
}
