// respond
// xmodem receive utility

#include "xmodem.h"

extern struct global
{ 
  volatile unsigned char *recv_ptr; 
  volatile unsigned char buffer_status;
  volatile unsigned char recv_error;
  volatile unsigned char t1_timed_out;
} gl;  
 
// function prototypes
void purge(void);
 
void respond(unsigned char packet) 
{
    // clear buffer flag here ... when acking or nacking sender may respond
    // very quickly.
    gl.buffer_status = empty;
    gl.recv_error = false; // framing and over run detection

    if ((packet == good) || (packet == dup) || (packet == end)) 
    {
        while (!(USR & 0x20)); // wait till transmit register is empty
        UDR = ACK; // now for the next packet
    }
    else 
    {
        while (!(USR & 0x20)); // wait till transmit register is empty
        purge(); // let transmitter empty its buffer
        UDR = NAK; // tell sender error
    }
}
