// validate_packet
// xmodem receive utility

#include "xmodem.h"

extern struct global
{ 
  volatile unsigned char *recv_ptr; 
  volatile unsigned char buffer_status;
  volatile unsigned char recv_error;
  volatile unsigned char t1_timed_out;
} gl;

// function prototypes
int calcrc(char *ptr, int count);

unsigned char validate_packet(unsigned char *bufptr,unsigned char packet_number) {

unsigned char packet;
int crc;
                     
    packet = bad;
    if (!gl.t1_timed_out) 
    {
        if (!gl.recv_error) 
        {
            if (bufptr[0] == SOH) 
            {                                                   // valid start
                if (bufptr[1] == ((packet_number+1) & 0xff)) 
                {                                               // sequential block number ?
                    if ((bufptr[1] + bufptr[2]) == 0xff) 
                    {                                           // block number and block number checksum are ok 
                        crc = calcrc(&bufptr[3],128);          // compute CRC and validate it                    
                        if ((bufptr[131] == (unsigned char)(crc >> 8)) && (bufptr[132] == (unsigned char)(crc))) 
                        {
                            packet_number++;                      // good packet ... ok to increment
                            packet = good;
                        }    
                    }                                // block number checksum
                }                                   // bad block number or same block number
                else if (bufptr[1] == ((packet_number) & 0xff)) 
                {                                   // same block number ... ack got glitched
                    packet = dup;                   // packet is previous packet don't inc packet number
                }
            }
            // check for the end            
            else if (bufptr[0] == EOT)
                packet = end;
        }
        else
            packet = err;
    }       
    else            
        packet = out;
    return (packet);
}
